{% extends "src/html/_template.njk" %}
{% set title = "Рейтинг связности российского сегмента интернета" %}
{% block content %}
    <section class="section section--white">
        <div class="block block--md">
            <div class="block__media">
                <img src="img/rating.svg" class="img-fluid" alt="">
            </div>
            <div class="h1 section__header">{{ title }}</div>
            <div class="block__content">
                Мы разрабатываем новые методики для оценки состояния связности российского сегмента сети Интернет и наглядно демонстрируем её текущее состояние и происходящие изменения online.
            </div>
        </div>
    </section><!-- .section -->

    <section class="section section--white">
        <div class="h3 mb">Мы наблюдаем за Рунетом и его параметрами:</div>
        <ul class="tags">
            <li>
                <a href="#" class="tag-item">
                    <i class="tag-item__media">
                        <i class="tag-item__icon">
                            <img src="img/tag-item.svg" class="img-fluid" alt="">
                        </i>
                    </i>
                    <span class="tag-item__text">Что с ним происходит</span>
                </a>
            </li>
            <li>
                <a href="#" class="tag-item">
                    <i class="tag-item__media">
                        <i class="tag-item__icon">
                            <img src="img/tag-item.svg" class="img-fluid" alt="">
                        </i>
                    </i>
                    <span class="tag-item__text">Как он развивается</span>
                </a>
            </li>
            <li>
                <a href="#" class="tag-item">
                    <i class="tag-item__media">
                        <i class="tag-item__icon">
                            <img src="img/tag-item.svg" class="img-fluid" alt="">
                        </i>
                    </i>
                    <span class="tag-item__text">Куда движется</span>
                </a>
            </li>
        </ul><!-- .tags -->
    </section><!-- .section -->

    <section class="section section--white">
        <div class="h3 mb">График устойчивости сети</div>
        <div class="chart-responsive">
            <div class="chart">
                <canvas id="myChart" width="1064" height="210"></canvas>
            </div>
        </div>
    </section><!-- .section -->

    <section class="section section--white">
        <div class="h3 mb">Параметры рейтинга</div>
        <div class="params">
            <a href="#" class="params__item">
                <div class="params__text">
                    Количество пар трансграничных автономных систем
                </div>
            </a>
            <a href="#" class="params__item">
                <div class="params__text">
                    Связь российского сегмента интернета с мировым: провайдеры
                </div>
            </a>
            <a href="#" class="params__item">
                <div class="params__text">
                    Россия: количество АС, маршрутизируемых сетей и адресов IPv4 и IPv6
                </div>
            </a>
            <a href="#" class="params__item">
                <div class="params__text">
                    Количество лицензий в области связи в РФ
                </div>
            </a>
        </div><!-- .params -->
    </section><!-- .section -->

    <section class="section">
        <div class="data-group">
            <div class="data-item">
                <div class="data-item__media">
                    <i>
                        <img src="img/post__net.svg" class="img-fluid" alt="">
                    </i>
                </div>
                <div class="data-item__text">Автономные сети в деталях</div>
            </div><!-- .data-item -->
            <div class="data-item">
                <div class="data-item__media">
                    <i>
                        <img src="img/post__block.svg" class="img-fluid" alt="">
                    </i>
                </div>
                <div class="data-item__text">Проверка блокировок</div>
            </div><!-- .data-item -->
            <div class="data-item">
                <div class="data-item__icon">
                    <img src="img/post__rating.svg" class="img-fluid" alt="">
                </div>
                <div class="data-item__text">О чем говорит рейтинг связности: рассказываем</div>
            </div><!-- .data-item -->
            <div class="data-item">
                <div class="data-item__icon">
                    <img src="img/post__method.svg" class="img-fluid" alt="">
                </div>
                <div class="data-item__text">Как мы делаем наш рейтинг связности: методология</div>
            </div><!-- .data-item -->
        </div>
    </section><!-- .section -->

{% endblock %}


{% block scripts %}
    <script src="js/app.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/4.1.1/chart.umd.min.js" integrity="sha512-RnIvaWVgsDUVriCOO7ZbDOwPqBY1kdE8KJFmJbCSFTI+a+/s+B1maHN513SFhg1QwAJdSKbF8t2Obb8MIcTwxA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    <script>

        if (document.querySelector('#myChart')) {

            const getOrCreateTooltip = (chart) => {
                let tooltipEl = chart.canvas.parentNode.querySelector('div');

                if (!tooltipEl) {
                    tooltipEl = document.createElement('div');
                    tooltipEl.style.background = 'rgba(0, 0, 0, 0.7)';
                    tooltipEl.style.borderRadius = '3px';
                    tooltipEl.style.color = 'white';
                    tooltipEl.style.opacity = 1;
                    tooltipEl.style.pointerEvents = 'none';
                    tooltipEl.style.position = 'absolute';
                    tooltipEl.style.transform = 'translate(-50%, 0)';
                    tooltipEl.style.transition = 'all .1s ease';

                    const table = document.createElement('table');
                    table.style.margin = '0px';

                    tooltipEl.appendChild(table);
                    chart.canvas.parentNode.appendChild(tooltipEl);
                }

                return tooltipEl;
            };

            const externalTooltipHandler = (context) => {
                // Tooltip Element
                const {chart, tooltip} = context;
                const tooltipEl = getOrCreateTooltip(chart);

                // Hide if no tooltip
                if (tooltip.opacity === 0) {
                    tooltipEl.style.opacity = 0;
                    return;
                }

                // Set Text
                if (tooltip.body) {
                    const titleLines = tooltip.title || [];
                    const bodyLines = tooltip.body.map(b => b.lines);

                    const tableHead = document.createElement('thead');

                    titleLines.forEach(title => {
                        const tr = document.createElement('tr');
                        tr.style.borderWidth = 0;

                        const th = document.createElement('th');
                        th.style.borderWidth = 0;
                        const text = document.createTextNode(title);

                        th.appendChild(text);
                        tr.appendChild(th);
                        tableHead.appendChild(tr);
                    });

                    const tableBody = document.createElement('tbody');
                    bodyLines.forEach((body, i) => {
                        const colors = tooltip.labelColors[i];

                        const span = document.createElement('span');
                        span.style.background = colors.backgroundColor;
                        span.style.borderColor = colors.borderColor;
                        span.style.borderWidth = '2px';
                        span.style.marginRight = '10px';
                        span.style.height = '10px';
                        span.style.width = '10px';
                        span.style.display = 'inline-block';

                        const tr = document.createElement('tr');
                        tr.style.backgroundColor = 'inherit';
                        tr.style.borderWidth = 0;

                        const td = document.createElement('td');
                        td.style.borderWidth = 0;

                        const text = document.createTextNode(body);

                        td.appendChild(span);
                        td.appendChild(text);
                        tr.appendChild(td);
                        tableBody.appendChild(tr);
                    });

                    const tableRoot = tooltipEl.querySelector('table');

                    // Remove old children
                    while (tableRoot.firstChild) {
                        tableRoot.firstChild.remove();
                    }

                    // Add new children
                    tableRoot.appendChild(tableHead);
                    tableRoot.appendChild(tableBody);
                }

                const {offsetLeft: positionX, offsetTop: positionY} = chart.canvas;

                // Display, position, and set styles for font
                tooltipEl.style.opacity = 1;
                tooltipEl.style.left = positionX + tooltip.caretX + 'px';
                tooltipEl.style.top = positionY + tooltip.caretY + 'px';
                tooltipEl.style.font = tooltip.options.bodyFont.string;
                tooltipEl.style.padding = tooltip.options.padding + 'px ' + tooltip.options.padding + 'px';
            };

            const myChart = document.querySelector('#myChart').getContext('2d');

            let gradientLine = myChart.createLinearGradient(0, 0, 0, 300);
            gradientLine.addColorStop(0, 'rgba(49, 39, 130, 1)');
            gradientLine.addColorStop(1, 'rgba(229, 0, 126, 1)');

            let gradientBg = myChart.createLinearGradient(0, 0, 0, 300);
            gradientBg.addColorStop(0, 'rgba(49, 39, 130, 0.2)');
            gradientBg.addColorStop(1, 'rgba(229, 0, 126, 0.01)');

            // Tags - метки по оси X.
            const tags = ['24 нояб', '25 нояб', '26 нояб', '27 нояб', '28 нояб', '29 нояб', '30 нояб', '1 дек', '2 дек', '3 дек', '4 дек', '5 дек', '6 дек']
            const dataValues = [40, 42, 18, 24, 26, 34, 15, 14, 20, 48, 30, 36, 56]
            const dataLabel = 'Сбои'

            new Chart(myChart, {
                type: 'line',// Тип графики
                data: {
                    labels: tags,
                    datasets: [
                        {
                            label: dataLabel,
                            data: dataValues, // Данные представляют собой массив, который должен иметь такое же количество значений, как и количество тегов.
                            backgroundColor: gradientBg, // Цвет фона
                            borderColor: gradientLine, // Цвет границ
                            borderWidth: 2,// Толщина границ
                            fill: true,
                            tension: 0.4,
                            pointBackgroundColor: 'rgba(255, 255, 255, 1)',
                            radius: 4,
                        }
                    ]
                },
                options: {
                    plugins: {
                        legend: {
                            display: false,
                        },
                    },
                    responsive: true,
                    scales: {
                        x: {
                            title: {
                                display: false,
                            }
                        },
                        y: {
                            title: {
                                display: false,
                            },
                            ticks: {
                                // forces step size to be 50 units
                                stepSize: 15
                            }
                        }
                    }
                }
            });
        }
    </script>
{% endblock %}
